object Driver extends App {
  import BST._

  val t1 = Tree(Tree(Nil,10,Nil),20,Tree(Nil,30,Nil))
  val t2 = Tree(Tree(Tree(Nil,10,Nil),20,Tree(Nil,30,Nil)),
                40,
                Tree(Tree(Nil,50,Nil),600,Tree(Nil,70,Nil)))
  val nums = List(47,34,97,88,41,20,16,105,100,83,99,97)
  val t3 = (nums foldLeft (Nil:BT))((l:BT,x:Int) => insertBST(x,l))
  val t4 = (nums foldRight (Nil:BT))((x:Int,l:BT) => insertBST(x,l))
  println("************************")
  println("Tree t3")
  printBST(t3)
  printBSTAsSet(t3)  
  println("************************")
  println("Tree t4")
  printBST(t4)
  printBSTAsSet(t4)  
  println("************************")

  println("isBST(t1)="+isBST(t1).toString)
  println("isBST(t2)="+isBST(t2).toString)

  println("minBST(t3)="+minBST(t3).toString)

  println("maxBST(t3)="+maxBST(t3).toString)

  println("memberBST(44,t3)="+memberBST(44,t3).toString)
  println("memberBST(47,t3)="+memberBST(47,t3).toString)

  val i1 = insertBST(24,t3)
  println("\ninsertBST(24,t3)="+toString2(insertBST(24,t3)))
  print("insertBST(24,t3) as a set=")
  printBSTAsSet(insertBST(24,t3))
  println()

  val i2 = insertBST(101,t3)
  println("\ninsertBST(101,t3)="+toString2(insertBST(101,t3)))
  print("insertBST(101,t3) as a set=")
  printBSTAsSet(insertBST(101,t3))
  println()

  val i3 = insertBST(97,t3)
  println("\ninsertBST(97,t3)="+toString2(insertBST(97,t3)))
  print("insertBST(97,t3) as a set=")
  printBSTAsSet(insertBST(97,t3))
  println()

  val i4 = insertBST(900,Nil)
  println("\ninsertBST(900,Nil)="+toString2(insertBST(900,Nil)))
  print("insertBST(900,Nil) as a set=")
  printBSTAsSet(insertBST(900,Nil))
  println()

  val d1 = deleteBST(83,t3)
  println("\ndeleteBST(83,t3)="+toString2(deleteBST(83,t3)))
  print("deleteBST(83,t3) as a set=")
  printBSTAsSet(deleteBST(83,t3))
  println()

  val d2 = deleteBST(105,t3)
  println("\ndeleteBST(105,t3)="+toString2(deleteBST(105,t3)))
  print("deleteBST(105,t3) as a set=")
  printBSTAsSet(deleteBST(105,t3))
  println()

  val d3 = deleteBST(97,t3)
  println("\ndeleteBST(97,t3)="+toString2(deleteBST(97,t3)))
  print("deleteBST(97,t3) as a set=")
  printBSTAsSet(deleteBST(97,t3))
  println()

  val d4 = deleteBST(22,t3)
  println("\ndeleteBST(22,t3)="+toString2(deleteBST(22,t3)))
  print("deleteBST(22,t3) as a set=")
  printBSTAsSet(deleteBST(22,t3))
  println()
  
  println("height of t3="+heightBST(t3).toString)
  println("height of t4="+heightBST(t4).toString)

  println("size of t3="+sizeBST(t3).toString)
}
