abstract class BT
case class tree(left: BT, symbols: Set[Char], weight: Int, right: BT) extends BT
case object nil extends BT

object Huffman {

  // Construct Huffman Tree from input, a list of single node binary trees
  def constructHuffmanTree(input: List[BT]): BT = ???

  // combines two trees t1 and t2 by making them children of a new node
  // whose weight is the sum of the weights of t1 and t2 and the symbols
  // are the union of the symbols of t1 and t2; returns the combined tree
  def combine(t1: BT, t2: BT): BT = ???

  // inserts tree t in list of trees ts keeping ts sorted in increasing order
  // of weights; returns new list of trees
  def insertHT(t: BT, ts: List[BT]): List[BT] = ???

  // Given a character c and the Huffman tree t, return code for c based on t
  def code(c: Char, t: BT): String =

  // Given a string s and the Huffman tree, encode the entire string based on t
  // This should call code(c,t) for each character in s and concatenate the results
  def huffmanEncoding(s: String, t: BT): String = ???

  // Given a list of 0s and 1s and the Huffman tree, htree, decode the string
  def decode(s: List[Char], htree: BT): String = ???

  // Given a string s of 0s and 1s and a Huffman tree t, decode the string
  // corresponding to s
  def huffmanDecoding(s: String, t: BT): String = ???

}
