import scala.math.abs

object Sqrt {
  def sqrt(x: Double) = {
    def sqrtIter(guess: Double): Double = 
      if (goodEnough(guess)) guess
      else sqrtIter(improve(guess))

    def improve(guess: Double) =
      (guess + x/guess)/2

    def goodEnough(guess: Double) =
      abs(guess*guess-x) < 0.001

    sqrtIter(1.0)
  }

  def main(args: Array[String]) {
    println(sqrt(19))
  }
}
